package consume

import (
	"applet/app/e"
	svc2 "applet/app/svc"
	"applet/app/utils"
	"applet/app/utils/logx"
	"applet/consume/md"
	utils1688 "applet/supply/1688/utils"
	"applet/supply/db"
	"applet/supply/db/model"
	"applet/supply/enum"
	md2 "applet/supply/md"
	"applet/supply/svc"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/gin-gonic/gin"
	"github.com/streadway/amqp"
	"strings"
	"time"
)

func SupplyCloudChainFenxiaoNewChangeConsume(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, false)

	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			fmt.Println(">>>>>>>>>>>>>>>>SupplyCloudChainFenxiaoNewChangeConsume<<<<<<<<<<<<<<<<<<<<<<<<<")
			//解析mq中queue的数据结构体
			var pushStuct struct {
				Args struct {
					md2.GoodsAddPriceConditions
				} `json:"args"`
				Mid string `json:"mid"`
			}
			err = json.Unmarshal(res.Body, &pushStuct)
			if err != nil {
				panic(err)
			}

			//设置masterId
			var c = &gin.Context{}
			c.Set("mid", pushStuct.Mid)
			var t struct {
				md2.GoodsAddPriceConditions
			}
			t = pushStuct.Args
			var idsMap = map[string]string{}
			for _, v := range t.Ids {
				idsMap[v] = v
			}
			var idsArray []string
			for _, v := range idsMap {
				idsArray = append(idsArray, v)
			}
			t.Ids = idsArray

			basicSetting, _ := svc.GetSupplyBasicSetting(c)
			if basicSetting == nil {
				fmt.Println("!!!!!功能开发中!!!!!")
				return
			}
			if basicSetting.AliCloudChainFenXiaoAppkey == "" || basicSetting.AliCloudChainFenXiaoAppsecret == "" || basicSetting.AliCloudChainFenXiaoAccesstoken == "" {
				fmt.Println("!!!!!必要参数没有填写，功能已暂停!!!!!")
				return
			}
			get, systemMerchant, err1 := db.GetSystemMerchant(svc2.MasterDb(c))
			if err1 != nil {
				fmt.Println(err1.Error(), "!!!!!!!!!!!!!!!!!!!!")
				return
			}
			if !get {
				fmt.Println("!!!!!请先去设置官方商家信息!!!!!")
				return
			}
			ids := RemoveRepeatedElement(t.Ids)

			goodsFrom1688s, err := utils1688.GetFenXiaoProductInfoFrom1688(basicSetting.AliCloudChainFenXiaoAppkey, basicSetting.AliCloudChainFenXiaoAppsecret, basicSetting.AliCloudChainFenXiaoAccesstoken, ids)
			if err != nil {
				logx.Error(err)
				continue
			}
			result, ok := goodsFrom1688s["result"].(map[string]interface{})
			if !ok {
				fmt.Println("错误的数据", "!!!!!!!!!!!!!!!!!!!!")
				return
			}
			if message, ok := result["message"]; ok {
				fmt.Println("!!!!!", message)
				return
			}
			resultList, ok := result["result"].([]interface{})
			if !ok {
				fmt.Println("!!!!!!错误的数据2!!!!!!!!!")
				return
			}
			if len(resultList) == 0 {
				fmt.Println("!!!!!!错误的数据3!!!!!!!!!")
				return
			}
			var cloudChainGoods = map[string]map[string]interface{}{}
			for _, v := range resultList {
				tmp, ok1 := v.(map[string]interface{})
				if !ok1 {
					fmt.Println("!!!!!!错误的数据3-1!!!!!!!!!")
					return
				}
				productInfo, ok1 := tmp["productInfo"].(map[string]interface{})
				if !ok1 {
					fmt.Println("!!!!!!错误的数据3-2!!!!!!!!!")
				}
				var productId = utils.AnyToString(productInfo["productID"])
				for strings.HasSuffix(productId, "0") {
					productId = strings.TrimSuffix(productId, "0")
				}
				if strings.HasSuffix(productId, ".") {
					productId = strings.TrimSuffix(productId, ".")
				}
				cloudChainGoods[productId] = tmp
			}

			utils.FilePutContents("cloudChainGoods", utils.SerializeStr(cloudChainGoods))
			go func() {
				for _, id := range ids {
					if cloudChainGoods[id] == nil {
						continue
					}
					var goods model.MallGoods
					goods.CloudChainGoodsId = id
					goods.MerchantId = systemMerchant.Id
					getV2, err11 := goods.GetV2(svc2.MasterDb(c))
					if err11 != nil {
						fmt.Println("!!!!!!", err11.Error())
						return
					}
					if getV2 {
						continue
					}
					var req md2.AddGoodsReq
					req.Base.GoodsType = 1
					req.Base.CloudChainGoodsId = id
					req.Base.SaleState = enum.MallGoodsSaleStateOnShelf
					req.Base.CategoryId = utils.StrToInt(t.CategoryId)
					req.Base.MerchantId = systemMerchant.Id

					err = svc.CloudChainFenXiaoGoodsChangeMallGoods(c, cloudChainGoods[id], &req)
					if err != nil {
						switch err.(type) {
						case e.E:
							err1 := err.(e.E)
							fmt.Println("!!!!!!", err1.Error())
							return
						default:
							fmt.Println("!!!!!!", err.Error())
							return
						}
					}

					err1 := svc.AddMallGoods(c, &req)
					if err1 != nil {
						switch err1.(type) {
						case e.E:
							err1 := err1.(e.E)
							fmt.Println("!!!!!!", err1.Error())
							return
						default:
							fmt.Println("!!!!!!", err.Error())
							return
						}
					}

					time.Sleep(10 * time.Millisecond)
				}
			}()
			_ = res.Ack(true)
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}

func RemoveRepeatedElement(arr []string) (newArr []string) {
	newArr = make([]string, 0)
	for i := 0; i < len(arr); i++ {
		repeat := false
		for j := i + 1; j < len(arr); j++ {
			if arr[i] == arr[j] {
				repeat = true
				break
			}
		}
		if !repeat {
			newArr = append(newArr, arr[i])
		}
	}
	return
}
